# -*- coding: utf_8 -*-
# by Claudemir de Almeida Rosa


import uno,unohelper

from com.sun.star.awt import Rectangle, WindowDescriptor
from com.sun.star.awt.WindowClass import MODALTOP
from com.sun.star.awt.VclWindowPeerAttribute import OK, OK_CANCEL, YES_NO, YES_NO_CANCEL, RETRY_CANCEL, DEF_OK, DEF_CANCEL, DEF_RETRY, DEF_YES, DEF_NO
from com.sun.star.task import XJobExecutor   
from com.sun.star.sheet.CellDeleteMode import UP
from com.sun.star.beans import PropertyValue



 

        
           

	
class Duplicates(unohelper.Base, XJobExecutor):
	
				
	def __init__(self, ctx):
		
		self.ctx = ctx				
		self.language=self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.i18n.LocaleData", self.ctx )
		desktop = self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.frame.Desktop", self.ctx ) 
		self.GlobalFunctions=self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.sheet.FunctionAccess", self.ctx )
		self.document = desktop.getCurrentComponent()
		self.lang=self.ctx.ServiceManager.createInstanceWithContext( "com.sun.star.configuration.ConfigurationProvider", self.ctx )
		
		

	  
		
	def trigger(self, args):
		
		# Obtem  o idioma
		properties = []
		arg = PropertyValue()
		arg.Name = "nodepath"
		arg.Value = "/org.openoffice.Setup/L10N" 
		properties.append(arg) 
		properties = tuple(properties)
		aSettings= self.lang.createInstanceWithArguments("com.sun.star.configuration.ConfigurationAccess", properties)
		code= aSettings.getByName("ooLocale") 
		
		oSel = self.document.getCurrentSelection()
		Sheet = oSel.getSpreadsheet()
		
		
		RangAreas = oSel.getRangeAddress()	
		
		
		oRangecolor=self.document.getCurrentSelection().getSpreadsheet().createCursorByRange(self.document.getCurrentSelection())
		CountA = oRangecolor.getCellByPosition(0,0)
		oCursor=Sheet.createCursorByRange(CountA)
		oCursor.gotoEndOfUsedArea(True)
		aAddress = oCursor.RangeAddress

		nStartCol= aAddress.StartColumn
		nEndCol = aAddress.EndColumn
		
		
	  	D=0
	  	cellsdel = []
	  	mylist = []
	  	if RangAreas.EndRow > 65534:
			lastCell=aAddress.EndRow
		else:
			lastCell=RangAreas.EndRow 
			
	  	for i in range(lastCell - RangAreas.StartRow +1 ):
			
					
			c = oRangecolor.getCellByPosition(0,i)
			values=c.getString().strip()

			if len(values)>0:   				
				
						if values not in mylist:
							mylist.append(values)
							
						else :               
							colorRange=Sheet.getCellRangeByPosition(0,RangAreas.StartRow+i,nEndCol,RangAreas.StartRow+i)

							colorRange.setPropertyValue( "CellBackColor", 0xFF0000)
					       						
							cellsdel.append(RangAreas.StartRow+i)
							 				
							D = D + 1
							
		if  D < 1:
			if code =='pt-BR':
				msg="Total de duplicados " + str(D) 
			else :
				msg="Total of duplicates " + str(D) 
				
			response=self.MessageBox(msg,OK) 					
		else :				
						
							
			if code=='pt-BR':
				
				msg="Total de duplicados " + str(D) + ", deseja remove-los ? " 
			else:
				msg="Total of duplicates " + str(D) + " , do you want remove duplicates?"
					
			response=self.MessageBox(msg,YES_NO) 
			if response == 2 :
				for i in cellsdel[::-1]:
				
					delRange=Sheet.getCellRangeByPosition(0,i,nEndCol,i)
					Sheet.removeRange(delRange.RangeAddress, UP)
				
					
		      
	def MessageBox(self, MsgText,WindowAttrib,MsgTitle="RemoveOOoDuplicates"):
		ParentWin = self.document.getCurrentController().Frame.ContainerWindow
		descriptor = WindowDescriptor()
		descriptor.Type = MODALTOP
		descriptor.WindowServiceName ="querybox" #available MsgTypes("messbox", "infobox", "errorbox", "warningbox", "querybox")
		descriptor.ParentIndex = -1
		descriptor.Parent = ParentWin
		descriptor.WindowAttributes = WindowAttrib #OK, OK_CANCEL, YES_NO, YES_NO_CANCEL, RETRY_CANCEL, DEF_OK, DEF_CANCEL, DEF_RETRY, DEF_YES, DEF_NO
		
		tk = ParentWin.getToolkit()
		msgbox = tk.createWindow(descriptor)
		
		msgbox.setMessageText(MsgText)
		msgbox.setCaptionText(MsgTitle)
		
		return msgbox.execute()
	
		
            
        
	

   

g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(Duplicates, 
	"org.openoffice.comp.pyuno.RemoveOOoDuplicates", 
	("com.sun.star.task.Job",),)    
